#!/usr/bin/perl

require 'mklink.cfg';

open( INFILE, "$InFile" ) || die "Cannot open $InFile\n";

while( <INFILE> ) {
	chop;
	s/#.*//;
	if( /^$/ ) {
		next;
	} elsif( /^C\t([^\t]+)\t(.+)$/ ) {
		&PutItem( $ID, $Url, $Title, $Desc );
		$Url = "";
		$Title = "";
		$Desc = "";
		$ID = $1;
		$Category = $2;
		push( @IDList, $1 );
		push( @CategoryList, $2 );
	} elsif( /^U\t(.+)$/ ) {
		&PutItem( $ID, $Url, $Title, $Desc );
		$Url = $1;
		$Title = "";
		$Desc = "";
	} elsif( /^T\t(.+)$/ ) {
		$Title = $1;
	} elsif( /^D\t(.+)$/ ) {
		$Desc = $1;
	} elsif( /^\t(.+)$/ ) {
		$Desc .= "\n$1";
	} else {
		print "Illegal line\n$_\n";
	}
}
close( INFILE );
&PutItem( $ID, $Url, $Title, $Desc );
&WriteNoFrame();
&WriteFrame();

sub PutItem
{
	local( $ID, $Url, $Title, $Desc ) = @_;
	if( $Url eq "" ) {
		return;
	}
	$Body{ $ID } .= "<DT><IMG SRC=\"$Pin\" ALT=\"*\">\n";
	$Body{ $ID } .= "<A HREF=\"$Url\" TARGET=\"_top\">$Title</A>\n";
	if( $Desc ne "" ) {
		$Body{ $ID } .= "<DD>$Desc\n";
	}
	$NFBody{ $ID } .= "<DT><IMG SRC=\"$Pin\" ALT=\"*\">\n";
	$NFBody{ $ID } .= "<A HREF=\"$Url\">$Title</A>\n";
	if( $Desc ne "" ) {
		$NFBody{ $ID } .= "<DD>$Desc\n";
	}
}

sub WriteNoFrame
{
	open( NOFRAME, "$Nkf>$OutPath$NoFrameFile" )
		|| die "Cannot open $NoFrameFile\n";
	select( NOFRAME );
	print <<EOF;
<HTML>
<HEAD>
<TITLE>Link!</TITLE>
</HEAD>
<BODY BACKGROUND=\"$BackGround\">
<CENTER>
<H1><A NAME=\"top\">Link!</A></H1>
EOF
	@tmpID = @IDList;
	@tmpCat = @CategoryList;
	while( @tmpID ) {
		$NowID = shift( @tmpID );
		$NowCat = shift( @tmpCat );
		print "<NOBR>[<A HREF=\"#$NowID\">$NowCat</A>]</NOBR>\n";
	}
	print "\n</CENTER>\n<HR>\n";
	@tmpID = @IDList;
	@tmpCat = @CategoryList;
	while( @tmpID ) {
		$NowID = shift( @tmpID );
		$NowCat = shift( @tmpCat );
		print "<H3><A NAME=\"$NowID\">$NowCat</A></H3>\n";
		print "<DL>\n" . $NFBody{$NowID} . "</DL>\n";
		print "<A HREF=\"#top\">ɤ</A><P>\n\n";
	}
	print <<EOF;
<HR>
<A HREF=\"$RetPath\">$RetDescɤ</A>
<HR>
$Footer
</BODY>
</HTML>
EOF
	close( NOFRAME );
}

sub WriteFrame
{
	open( OUT, "$Nkf>$OutPath"."category.html" )
		|| die "Cannot open category.html\n";
	select( OUT );
	print <<EOF;
<HTML>
<HEAD>
<TITLE>Link!</TITLE>
</HEAD>
<BODY BACKGROUND=\"$BackGround\">
<CENTER>
<H1>Link!</H1>
EOF
	@tmpID = @IDList;
	@tmpCat = @CategoryList;
	while( @tmpID ) {
		$NowID = shift( @tmpID );
		$NowCat = shift( @tmpCat );
		print "<NOBR>[<A HREF=\"$NowID.html\" TARGET=\"links\">"
			. "$NowCat</A>]</NOBR>\n";
	}
	print "<NOBR>[<A HREF=\"$RetPath\" TARGET=\"_top\">"
		. "$RetDesc</A>]</NOBR>";
	print "\n</CENTER>\n</BODY></HTML>\n";
	close( OUT );

	@tmpID = @IDList;
	@tmpCat = @CategoryList;
	while( @tmpID ) {
		$NowID = shift( @tmpID );
		$NowCat = shift( @tmpCat );
		open( OUT, "$Nkf>$OutPath$NowID.html")
			|| die "Cannot open $NowID.html\n";
		select( OUT );
		print "<HTML><BODY BACKGROUND=\"$BackGround\">\n";
		print "<H3>$NowCat</H3>\n";
		print "<DL>\n" . $Body{$NowID} . "</DL>\n";
		print <<EOF;
<HR>
$Footer
</BODY>
</HTML>
EOF
		close( OUT );
	}
}
